////////////////////////////////////////////////////////////////////////////////
//	タイマーガジェット
//		Copyright (C) 2008 - 2009 AAOh inc.
////////////////////////////////////////////////////////////////////////////////

// 設定情報(JSON)
var settingData = {
	"ttl1"  : getLocalizedString("TTL_SET1"),
	"time1" : 180000, // 3min
	"ttl2"  : getLocalizedString("TTL_SET2"),
	"time2" : 60000, // 1min
	"ttl3"  : getLocalizedString("TTL_SET3"),
	"time3" : 30000, // 30src

	"timer"       : "timer1",
	"start"       : "start1",
	"startPush"   : "startPush1",
	"stop"        : "stop1",
	"stopPush"    : "stopPush1",
	"suspend"     : "suspend1",
	"suspendPush" : "suspendPush1",
	"bg"          : "onDoc1",
	"sound"       : true,
	"strSound"    : "alert.wav",
	"alertMsg"    : false,
	"strAlertMsg" : getLocalizedString("SETTING_ALERT_MSG"),
	"mode"        : MODE_COUNTDOWN,
	"lang"        : "ja",
	"chkUpdTime"  : 0,
	"chkUpdUrl"   : null
};
var positionData = {
	"x" : 100,
	"y" : 100
};

if(isAIR()){
	settingData.ttl1        = window.parent.getLocalizedString("TTL_SET1");
	settingData.ttl2        = window.parent.getLocalizedString("TTL_SET2");
	settingData.ttl3        = window.parent.getLocalizedString("TTL_SET3");
	settingData.strSound    = "alert.mp3";
	settingData.strAlertMsg = window.parent.getLocalizedString("SETTING_ALERT_MSG");
}

// 計測時間(msec)
var measureTime = 0;

// 終了時間(msec)
var stopTime = 0;

// 一時停止時間(Date)
var suspendDate = null;

// 状態フラグ
var flgSts = FLG_STOP;

var iid1 = null;
var iid2 = null;

var flgOnDoc = true;

var updChkIid = null;

var airSoundChannel = null;

/**
 * タイマー時間設定。
 *
 * @param setNo 設定番号
 */
function setStartTime(setNo){
	// 計測状態の設定
	flgSts      = FLG_STOP;
	stopTime    = 0;
	suspendDate = null;
	setStartImg();
	setStopImg();

	// 開始時間の設定
	switch(setNo){
		case 1:
			measureTime = settingData.time1;
			break;
		case 2:
			measureTime = settingData.time2;
			break;
		case 3:
			measureTime = settingData.time3;
			break;

		case 0:
		default:
			break;
	}

	if(iid1 != null){
		// アラート表示の初期化
		clearInterval(iid1);
		clearInterval(iid2);
		iid1 = null;
		iid2 = null;

		stopSound();
	}

	// 画面表示
	showTimer(measureTime);
}

/**
 * 開始ボタンのイメージ変更。
 */
function setStartImg(){
	// 開始
	if(flgSts == FLG_STOP || flgSts == FLG_SUSPEND){
		$("btn_start").className = settingData.start;

	// 一時停止
	} else if(flgSts == FLG_START){
		$("btn_start").className = settingData.suspend;
	}

	$("lbl_timer").className = settingData.timer;
}

/**
 * 開始ボタンのイメージ変更。
 */
function setStartPushImg(){
	// 開始
	if(flgSts == FLG_STOP || flgSts == FLG_SUSPEND){
		$("btn_start").className = settingData.startPush;

	// 一時停止
	} else if(flgSts == FLG_START){
		$("btn_start").className = settingData.suspendPush;
	}
}

/**
 * 停止ボタンのイメージ変更。
 */
function setStopImg(){
	$("btn_stop").className = settingData.stop;
}

/**
 * 停止ボタンのイメージ変更。
 */
function setStopPushImg(){
	$("btn_stop").className = settingData.stopPush;
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function setImgInput(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		return;
	}

	switch(key){
		// エンター
		case 13:
			setStartPushImg();
			break;

		// エスケープ
		case 27:
			setStopPushImg();
			break;

		default:
			break;
	}
}

/**
 * タイマー開始、一時停止。
 */
function doStart(){
	// 開始
	if(flgSts == FLG_STOP || flgSts == FLG_SUSPEND){
		flgSts = FLG_START;
		setStartImg();

		// 計測時刻の設定
		var nowTime = new Date().getTime()
		if(suspendDate == null){
			stopTime = nowTime + measureTime;

		} else {
			var suspendTime = nowTime - suspendDate.getTime();
			stopTime = stopTime + suspendTime;

			// 一時停止時間のクリア
			suspendDate = null;
		}

		if(iid1 != null){
			// アラート表示の初期化
			clearInterval(iid1);
			clearInterval(iid2);
			iid1 = null;
			iid2 = null;

			stopSound();
		}

		// タイマー開始
		timer();

	// 一時停止
	} else if(flgSts == FLG_START){
		flgSts = FLG_SUSPEND;
		setStartImg();

		// 一時停止時間の設定
		suspendDate = new Date();
	}
}

/**
 * タイマー停止。
 */
function doStop(){
	setStartTime(0);
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function doInput(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		return;
	}

	switch(key){
		// エンター
		case 13:
			doStart();
			break;

		// エスケープ
		case 27:
			doStop();
			break;

		default:
			break;
	}
}

/**
 * 設定画面が表示されたとき。
 */
function doSetting(){
	doStop();
}

/**
 * 設定画面が閉じられた時。
 */
function doSettingClosed(){
	// 設定情報の読込み
	readData();

	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * フォーカス設定。
 */
function setFocus(){
	// ボタンが連打できないようにする
	// opera widget対応
	try{
		$("txt_timer").focus();
	}catch(ex){
		$("bdy_timer").focus();
	}
}

/**
 * スライドバーにドックされたとき。
 */
function showOnDoc(){
	$("div_timer").className = settingData.bg;

	$("btn_set1").value = settingData.ttl1;
	$("btn_set2").value = settingData.ttl2;
	$("btn_set3").value = settingData.ttl3;
	setStartImg();
	setStopImg();

	flgOnDoc = true;
}

/**
 * スライドバーからアンドックされたとき。
 */
function showUnDoc(){
	$("div_timer").className = "unDoc";

	$("btn_set1").value = settingData.ttl1;
	$("btn_set2").value = settingData.ttl2;
	$("btn_set3").value = settingData.ttl3;
	setStartImg();
	setStopImg();

	flgOnDoc = false;
}

/**
 * 計測時間の表示。
 *
 * @param remainTime 残時間
 */
function showTimer(remainTime){
	var hourNum = parseInt(remainTime / (60 * 60 * 1000));
	var minNum  = parseInt((remainTime - (hourNum * 60 * 60 * 1000)) / (60 * 1000));
	var secNum  = parseInt((remainTime % (60 * 1000)) / 1000);
	var msecNum = parseInt(remainTime % 1000);

	// 時間の編集
	var hour = String(hourNum);
	var min  = String(minNum);
	var sec  = String(secNum);
	var msec = String(msecNum);
	if(min.length < 2){
		min = "0" + min;
	}
	if(sec.length < 2){
		sec = "0" + sec;
	}
	if(msec.length < 2){
		//msec = "0" + msec;
		msec = "0";
	} else {
		//msec = msec.substring(0, 2);
		msec = msec.substring(0, 1);
	}

	// 時間の表示
	//$("lbl_timer").innerHTML = min + ":" + sec + ":" + msec;
	$("lbl_timer_main").innerHTML = hour + ":" + min + ":" + sec;
	$("lbl_timer_sub").innerHTML  = "." + msec;
}

/**
 * アラート表示。
 */
function showAlert(){
	flgSts   = FLG_STOP;
	stopTime = 0;

	// アラート表示
	$("btn_start").className = settingData.start;
	//$("lbl_timer").innerHTML = "00:00:00";
	var remainTime = 0;
	switch(settingData.mode){
		case MODE_COUNTDOWN:
		default:
			remainTime = 0;
			break;

		case MODE_COUNTUP:
			remainTime = measureTime;
			break;
	}
	showTimer(remainTime);

	// アラートメッセージ表示
	if(settingData.alertMsg){
		if(isOpera()){
			widget.showNotification(settingData.strAlertMsg, doStop);

		} else if(isAIR()){
			//setTimeout(function(){
			//	var flgConf = confirm(settingData.strAlertMsg); if(flgConf){ doStop(); }
			//}, 100);

		} else {
			setTimeout('var flgConf = new ActiveXObject("WScript.Shell").Popup(settingData.strAlertMsg); if(flgConf == 1){ doStop(); }', 100);
		}
	}

	showTimerAlert();
	showTimerAlertSound();
}

/**
 * アラート表示。
 */
function showTimerAlert(){
	$("lbl_timer").className = "timerAlert";
	if(!isAIR()){
		setTimeout('$("lbl_timer").className = settingData.timer', 500);

	} else {
		setTimeout(function(){
			$("lbl_timer").className = settingData.timer
		}, 500);
	}

	// sbm対応
	if(isSBM()){
		// バイブレーション
		widget.system.vibrate(5); // 500msec
	}

	if(iid1 == null){
		if(!isAIR()){
			iid1 = setInterval('showTimerAlert()', 1000);

		} else {
			iid1 = setInterval(showTimerAlert, 1000);
		}
	}
}

/**
 * アラート表示。
 */
function showTimerAlertSound(){
	// 音を鳴らす
	if(settingData.sound){
		if(settingData.strSound != null && settingData.strSound != ""){
			doSound();

		} else {
			doSoundBeep();
		}

	} else {
		return;
	}

	if(iid2 == null){
		if(!isAIR()){
			iid2 = setInterval('showTimerAlertSound()', 3000);

		} else {
			iid2 = setInterval(showTimerAlertSound, 3000);
		}
	}
}

/**
 * 時間計測。
 */
function timer(){
	if(flgSts != FLG_START){
		return;
	}

	// 計測時刻の判定
	var time       = new Date().getTime();
	var remainTime = stopTime - time;
	if(remainTime <= 0){
		// アラート処理
		showAlert();
		return;
	}

	switch(settingData.mode){
		case MODE_COUNTDOWN:
		default:
			break;

		case MODE_COUNTUP:
			remainTime = measureTime - remainTime;
			break;
	}

	showTimer(remainTime);
	if(!isAIR()){
		setTimeout('timer()', INTERVAL);

	} else {
		setTimeout(timer, INTERVAL);
	}
}

/**
 * 設定情報の初期化。
 */
function initSettingData(){
	// 画面表示の設定
	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}

	// 初期設定の設定
	setStartTime(1);
}

/**
 * 更新チェックするか。
 *
 * @return 更新チェックするときにはtrue
 */
function isCheckUpdate(){
	var flgChkUpd = false;

	// 未チェックだったら必ずtrue
	if(settingData.chkUpdTime <= 0){
		return true;
	}

	// 更新イメージ表示中だったら必ずtrue
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		return true;
	}

	var nowDate   = new Date();
	var nextDate  = new Date(settingData.chkUpdTime);

	// 1ヶ月後を設定
	nextDate.setMonth(nowDate.getMonth() + UPDATE_INTERVAL_MONTH);

	if(nowDate.getTime() > nextDate.getTime()){
		// 更新チェックを行う
		flgChkUpd = true;
	}

	return flgChkUpd;
}

/**
 * 更新なしイメージの設定。
 */
function showUpdateNon(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NON;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NON");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NON");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NON + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" border="0">';
	}
}

/**
 * チェック中イメージの設定。
 */
function showUpdateNow(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NOW;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NOW + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" border="0">';
	}
}

/**
 * 更新イメージの設定。
 */
function showUpdate(){
	var imgUpd = $("img_upd");
	imgUpd.src   = IMG_SRC_UPDATE;
	imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE");
	imgUpd.title = getLocalizedString("IMG_ALT_UPDATE");

	var aUpd = $("a_upd");
	if(aUpd == null){
		// dashboard対応
		var onclickFnuc = "";
		if(isDashboard()){
			onclickFnuc = ' onclick="window.widget.openURL(this.href); return false;"';
		} // if(!!window.widget && !window.opera)
		if(isAIR()){
			onclickFnuc = ' onclick="air.navigateToURL(new air.URLRequest(this.href)); return false;"';
		} // if(isAIR())

		var divUpd = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML = '<a id="a_upd" href="' + settingData.chkUpdUrl +'"' + onclickFnuc + '>' + imgUpdHtml + '</a>';

	} else {
		aUpd.href = settingData.chkUpdUrl;
	}
}

/**
 * 更新チェック。
 * 更新チェックはPC起動時または1日毎に行う。
 */
function checkUpdate(){
	if(updChkIid != null){
		clearTimeout(updChkIid);
		updChkIid = null;
	}

	try{
		doCheckUpdate();
	}catch(ex){
	}

	if(!isAIR()){
		updChkIid = setTimeout('checkUpdate()', UPDATE_CEHCK_INTERVAL_TIME);

	} else {
		updChkIid = setTimeout(checkUpdate, UPDATE_CEHCK_INTERVAL_TIME);
	}
}

/**
 * 更新表示。
 */
function doCheckUpdate(){
	// 更新イメージの初期設定
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}

	// 更新チェックするか
	var flgChkUpd = isCheckUpdate();
	if(!flgChkUpd){

		// 今回は更新チェックを行わない
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		return;
	}

	// 更新イメージをチェック中にする
	showUpdateNow();

	// Firefox対応
	try{
		if(netscape){
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}
	}catch (ex){
	}

	var updateUrl = null;
	if(isOpera()){
		updateUrl = OPERA_UPDATE_URL;

	} else if(isDashboard()){
		updateUrl = DASHBOARD_UPDATE_URL;

	} else if(isAIR()){
		updateUrl = AIR_UPDATE_URL;

	} else if(isSBM()){
		updateUrl = SBM_UPDATE_URL;

	} else {
		updateUrl = VISTA_UPDATE_URL;
	}

/*
	// 非同期だとうまく動作しない
	var chkUpdReq = new Ajax.Request(
		updateUrl, {
			method       : "get",
			parameters   : "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime(),
//			onLoaded     : function(){
//				// 更新イメージをチェック中にする
//				var imgUpd = $("img_upd");
//				imgUpd.src   = IMG_SRC_UPDATE_NOW;
//				imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
//				imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");
//			},
			//onComplete   : showCheckUpdate,
			asynchronous : false,
			onFailure    : checkUpdateError,
			onException  : checkUpdateException
		}
	);
*/

	// 最新バージョンの取得
	var parameters = "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime();
	var resTxt     = null;
	try{
		// Ajax通信
		// 非同期だとうまく動作しない
		if(!isAIR()){
			resTxt = ajax.gets(updateUrl + "?" + parameters);

		} else {
			var request = new air.URLRequest(updateUrl + "?" + parameters);
			var loader  = new air.URLLoader();
			loader.addEventListener(air.Event.COMPLETE, function(event){
				showCheckUpdate(event.target.data);
			});
			loader.load(request);
			return;
		}

	}catch(ex){
		checkUpdateError(ex);
		return;
	}

	// レスポンスを作成
/*
	var chkUpdRes = new Ajax.Response(chkUpdReq);
	showCheckUpdate(chkUpdRes);
*/
	showCheckUpdate(resTxt);
}

/**
 * 更新表示。
 *
 * @param resTxt レスポンスオブジェクト
 */
function showCheckUpdate(resTxt){
	var flgUpd = false;

	// 更新チェックデータの取得
	var chkUpdData = null;
	if(resTxt != null){
		try{
			//chkUpdData = resTxt.evalJSON();
			chkUpdData = JSON.parse(resTxt);

		}catch(ex){
			checkUpdateException(ex);
			return;
		}
	}

	if(
		chkUpdData == null
		|| chkUpdData[GADGET_NAME] == null
	){
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// バージョンチェック
	if(nowVer != chkUpdData[GADGET_NAME].version){
		var nowVerList = nowVer.split(".");
		var updVerList = chkUpdData[GADGET_NAME].version.split(".");
		for(var cnt = 0 ; cnt < nowVerList.length ; cnt++){
			if(cnt >= updVerList.length){
				break;
			}

			var nowVerSub = parseInt(nowVerList[cnt]);
			var updVerSub = parseInt(updVerList[cnt]);
			if(nowVerSub < updVerSub){
				flgUpd = true;
				break;

			} else if(nowVerSub > updVerSub){
				break;
			}
		} // for(var cnt = 0 ; cnt < nowVerList.length ; cnt++)
	}

	// 更新イメージ設定
	if(flgUpd){
		settingData.chkUpdUrl = chkUpdData[GADGET_NAME].url;

		// 更新イメージにする
		showUpdate();

	} else {
		settingData.chkUpdUrl = null;

		// 更新なしイメージにする
		showUpdateNon();
	}


	// 更新チェック日付の更新
	settingData.chkUpdTime = new Date().getTime();
	writeData();
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateError(res){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateException(res, ex){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * 音を鳴らします。
 */
function doSound(){
	try{
		startSound(settingData.strSound);

	}catch(ex){
		settingData.strSound = "";
		writeData();
	}
}

/**
 * 音を鳴らします。
 *
 * @param strSound 音源ファイル名
 */
function startSound(strSound){
	if(!isAIR()){
		System.Sound.playSound("");
		System.Sound.playSound(strSound);

	} else {
		if(airSoundChannel != null){
			airSoundChannel.stop();
		}
		var sound = new air.Sound(
			new air.URLRequest(strSound)
		);
		airSoundChannel = sound.play(0);
	}
}

/**
 * 音を止めます。
 */
function stopSound(){
	try{
		if(!isAIR()){
			System.Sound.playSound("");

		} else {
			if(airSoundChannel != null){
				airSoundChannel.stop();
			}
		}

	}catch(ex){
	}
}

/**
 * 音を鳴らします。
 */
function doSoundBeep(){
	try{
		System.Sound.beep();

	}catch(ex){
		settingData.sound = false;
		writeData();
	}
}


/**
 * バージョン情報の取得。
 */
function getVersion(){
	var ver = "";

	try{
		//ver = System.Gadget.version;
		ver = VERSION;

	}catch(ex){
	}

	return ver;
}

/**
 * 設定情報の読込み。
 *
 * @return 読込んだ設定情報
 */
function getReadData(){
	var readValue = null;

	try{
		if(isVista()){
			readValue = System.Gadget.Settings.readString(SETTING_NAME);

		} else if(isAIR()){
			var dir  = air.File.applicationStorageDirectory;
			var file = dir.resolvePath(SETTING_NAME + ".json");

			if(file.exists){
				var fileStream = new air.FileStream();
				fileStream.open(file, air.FileMode.READ);
				readValue = fileStream.readUTFBytes(fileStream.bytesAvailable);
				fileStream.close();
			}

		} else {
			readValue = widget.preferenceForKey(SETTING_NAME);
		}
	}catch(ex){
	}

	var readData_ = null;
	if(readValue != null && readValue != ""){
		try{
			//readData_ = readValue.evalJSON();
			readData_ = JSON.parse(readValue);

		}catch(ex){
		}
	}

	return readData_;
}

/**
 * 設定情報の読込み。
 */
function readData(){
	var readData_ = getReadData();

	if(readData_ != null && readData_ != ""){
		settingData = readData_;
	}
}

/**
 * 設定情報の書込み。
 *
 * @param writeData 書込む設定情報
 */
function setWriteData(writeData){
	try{
		//var writeValue = Object.toJSON(writeData);
		var writeValue = JSON.stringify(writeData);

		if(isVista()){
			System.Gadget.Settings.writeString(SETTING_NAME, writeValue);

		} else if(isAIR()){
			var dir     = air.File.applicationStorageDirectory;
			var file    = dir.resolvePath(SETTING_NAME + ".json");

			var fileStream = new air.FileStream();
			fileStream.open(file, air.FileMode.WRITE);
			fileStream.writeUTFBytes(writeValue);
			fileStream.close();

		} else {
			widget.setPreferenceForKey(writeValue, SETTING_NAME);
		}
	}catch(ex){
	}
}

/**
 * 設定情報の書込み。
 */
function writeData(){
	setWriteData(settingData);
}

/**
 * 設定情報の読込み。
 *
 * @return 読込んだ設定情報
 */
function getReadPosition(){
	if(!isAIR()){
		return null;
	}
	var readValue = null;

	try{
		var dir  = air.File.applicationStorageDirectory;
		var file = dir.resolvePath(SETTING_NAME + ".position.json");

		if(file.exists){
			var fileStream = new air.FileStream();
			fileStream.open(file, air.FileMode.READ);
			readValue = fileStream.readUTFBytes(fileStream.bytesAvailable);
			fileStream.close();
		}

	}catch(ex){
	}

	var readData_ = null;
	if(readValue != null && readValue != ""){
		try{
			//readData_ = readValue.evalJSON();
			readData_ = JSON.parse(readValue);

		}catch(ex){
		}
	}

	return readData_;
}

/**
 * 設定情報の読込み。
 */
function readPosition(){
	var readData_ = getReadPosition();

	if(readData_ != null && readData_ != ""){
		positionData = readData_;
	}
}

/**
 * 設定情報の書込み。
 *
 * @param writeData 書込む設定情報
 */
function setWritePosition(writeData){
	if(!isAIR()){
		return null;
	}

	try{
		//var writeValue = Object.toJSON(writeData);
		var writeValue = JSON.stringify(writeData);

		var dir     = air.File.applicationStorageDirectory;
		var file    = dir.resolvePath(SETTING_NAME + ".position.json");

		var fileStream = new air.FileStream();
		fileStream.open(file, air.FileMode.WRITE);
		fileStream.writeUTFBytes(writeValue);
		fileStream.close();

	}catch(ex){
	}
}

/**
 * 設定情報の書込み。
 */
function writePosition(){
	setWritePosition(positionData);
}

/**
 * 初期処理。
 */
function init(){
	setEventListener();
	setGadgetEventListener();
	readData();
	if(isAIR()){
		readPosition();
		window.nativeWindow.x = positionData.x;
		window.nativeWindow.y = positionData.y;

		$("txt_timer").className  = "hide";
	}

	// ソフトバンクモバイルかの判定
	if(!isSBM()){

		// 設定画面の読込み
		$("if_setting").src = "timer-setting.html";

	} else {
		setMobilePhone();
	}

	// 画面表示の設定
	setLocalized(settingData.lang);
	initSettingData();
	if(FLG_UPDATE){
		checkUpdate();
	}
	setFocus();
}

/**
 * イベントリスナーの設定。
 */
function setEventListener(){
	// キー入力の設定
	document.onkeyup = doInput;

	// onclickの設定
	$("btn_set1").onclick = function(){ setStartTime(1); setFocus(); };
	$("btn_set2").onclick = function(){ setStartTime(2); setFocus(); };
	$("btn_set3").onclick = function(){ setStartTime(3); setFocus(); };

	$("btn_start").onclick = function(){ doStart(); setFocus(); };
	$("btn_stop").onclick  = function(){ doStop();  setFocus(); };

	document.onkeydown = function(){ setImgInput(event); setFocus(); };
	$("btn_start").onmousedown = setStartPushImg;
	$("btn_start").onmouseup   = setStartImg;
	$("btn_start").onmouseout  = setStartImg;
	$("btn_stop").onmousedown  = setStopPushImg;
	$("btn_stop").onmouseup    = setStopImg;
	$("btn_stop").onmouseout   = setStopImg;

	if(isAIR()){
		$("div_timer").onmousedown = function(){ window.nativeWindow.startMove(); };
	}
}

/**
 * ガジェットイベントリスナーの設定。
 */
function setGadgetEventListener(){
	try{
		flgOnDoc = System.Gadget.docked;

		// ドックの状態設定
		System.Gadget.onDock   = showOnDoc;
		System.Gadget.onUndock = showUnDoc;

		// 設定画面の設定
		System.Gadget.settingsUI        = "timer-setting.html";
		System.Gadget.onShowSettings    = doSetting;
		System.Gadget.onSettingsClosed  = function(){ doSettingClosed(); setFocus(); };

	}catch(ex){
		// ツールバーの表示
		$("td_setting").className = "";

		//// 最大化ボタン(unDoc)
		//$("btn_max").onclick = function(){
		//	if(flgOnDoc){
		//		showUnDoc();
		//	} else {
		//		showOnDoc();
		//	}
		//};

		// 設定ボタン
		if(!!window.JSON){
			$("btn_conf").onclick = function(){
				doSetting();
				$("if_setting").className = "";
				//$("btn_max").className    = "hide";
				$("div_timer").className  = "hide";

				if(isMobile()){
					window.resizeTo(WINDOW_SETTING_MOBILE_WIDTH, WINDOW_SETTING_MOBILE_HEIGHT);
				} else {
					window.resizeTo(WINDOW_SETTING_WIDTH, WINDOW_SETTING_HEIGHT);
				} // if(isMobile())
			}

		} else {
			$("btn_conf").className = "hide";
		}

		if(isOpera()){
			// 閉じるボタン
			$("btn_close").onclick = function(){
				window.close();
			};

		} else if(isAIR()){
			// 閉じるボタン
			$("btn_close").onclick = function(){
				positionData.x = window.nativeWindow.x;
				positionData.y = window.nativeWindow.y;
				writePosition();

				air.NativeApplication.nativeApplication.exit();
			};

		} else {
			$("btn_close").className = "hide";
		}
	}
}

/**
 * ソフトバンクモバイル用設定。
 */
function setMobilePhone(){
	FLG_UPDATE = false;
	$("div_toolbar").className = "hide";

	settingData.sound    = false;
	settingData.alertMsg = false;
}

// 初期処理
document.body.onload = init();

